#!/usr/bin/python3
import dbus
import dbus.service
from dbus.mainloop.glib import DBusGMainLoop
from gi.repository import GLib

import os, shutil

class KYSettingsDBusSessionService(dbus.service.Object):
    def __init__(self, bus_name, object_path):
        dbus.service.Object.__init__(self, bus_name, object_path)

    @dbus.service.method("com.kylin.kysdk.conf2")
    def Init(self):
        source_file = '/etc/kylin-config/user.db'
        destination_file = '~/.config/kylin-config/user.db'
        destination_file = os.path.expanduser(destination_file)
        if not os.path.exists(destination_file):
            os.makedirs(os.path.dirname(destination_file), exist_ok=True)
            shutil.copyfile(source_file, destination_file)

if __name__ == "__main__":

    DBusGMainLoop(set_as_default=True)

    bus_session = dbus.SessionBus()
    object_path = '/com/kylin/kysdk/conf2'
    bus_sesssion_name = dbus.service.BusName("com.kylin.kysdk.conf2", bus = bus_session)
    my_dbus_session_service = KYSettingsDBusSessionService(bus_sesssion_name, object_path)
    my_dbus_session_service.Init()

    mainloop = GLib.MainLoop()
    mainloop.run()